<!DOCTYPE html>
<html lang="en">
<head>
    <title>InsertUser</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>
<body>
    <div class="container">
        <div class="text-center my-4">
            <h2>Thêm mới User</h2>
        </div>
        <div class="form-group">
            <label>First Name</label>
            <input type="text" id="inp-firstname" class="form-control" placeholder="Nhập vào First Name">
        </div>
        <div class="form-group">
            <label>Last Name</label>
            <input type="text" id="inp-lastname" placeholder="Nhập vào Last Name" class="form-control">
        </div>
        <div class="form-group">
            <label>Country</label>
            <select class="form-control" id="select-country">
                <option value="0">...</option>
                <option value="VN">Việt Nam</option>
                <option value="USA">USA</option>
                <option value="AUS">Australia</option>
                <option value="CAN">Canada</option>
            </select>
        </div>
        <div class="form-group">
            <label>Customer Type</label>
            <select class="form-control" id="select-customerType">
                <option value="0">...</option>
                <option value="Standard">Standard</option>
                <option value="Gold">Gold</option>
                <option value="Premium">Premium</option>
            </select>
        </div>
        <div class="form-group">
            <label>Subject</label>
            <textarea class="form-control" placeholder="Nhập vào Subject" type="text" id="textarea-subject"></textarea>
        </div>
        <div class="">
            <button class="btn btn-success float-right" id="btn-them-moi">Thêm mới</button>
        </div>
    </div>
</body>
<script>
    "use strict";
    //REGION 1

    //REGION 2
    $(document).ready(function(){
        $("#btn-them-moi").on("click", function(){
            onBtnThemMoiClick(this);
        });
    })
    //REGION 3
    function onBtnThemMoiClick(){
        console.log("nút thêm mới được ấn");
        //b1: khai báo đối tượng lưu dữ liệu
        //thu thập dữ liệu
        var vUserObj = {
            firstName: "",
            lastName: "",
            country: "",
            customerType: "",
            subject: ""
        }
        getFormData(vUserObj);
        console.log(vUserObj.firstName);
        console.log(vUserObj.lastName);
        console.log(vUserObj.country);
        console.log(vUserObj.customerType);
        console.log(vUserObj.subject);
        //b2 kiểm tra dữ liệu
        var vIsCheck = valiDataUserObj(vUserObj);
        if(vIsCheck){
            //b3 gọi ajax post api
            callAjaxPostApiUser(vUserObj);
        }
        


    }
    //REGION 4
    //hàm thu thập dữ liệu
    function getFormData(paramObj){
        paramObj.firstName = $("#inp-firstname").val().trim();
        paramObj.lastName = $("#inp-lastname").val().trim();
        paramObj.country = $("#select-country").val();
        paramObj.customerType = $("#select-customerType").val();
        paramObj.subject = $("#textarea-subject").val().trim();
    }
    //hàm kiểm tra dữ liệu
    function valiDataUserObj(paramUser){
        if(paramUser.firstName == ""){
            alert("Bạn chưa nhập first name");
            $("#inp-firstname").focus();
            return false;
        }
        if(paramUser.lastName == ""){
            alert("Bạn chưa nhập last name");
            $("#inp-lastname").focus();
            return false;
        }
        if(paramUser.country == 0){
            alert("Bạn chưa chọn country");
            $("#select-country").focus();
            return false;
        }
        if(paramUser.customerType == 0){
            alert("Bạn chưa chọn Customer type");
            $("#select-customerType").focus();
            return false;
        }
        if(paramUser.subject == ""){
            alert("Bạn chưa nhập subject");
            $("#textarea-subject").focus();
            return false;
        }
        return true;
    }
    //hàm gọi ajax post api để thêm use
    function callAjaxPostApiUser(paramUserObj){
        $.ajax({
            url: "http://203.171.20.210:8080/crud-api/users/",
            type: "POST",
            data: JSON.stringify(paramUserObj),
            contentType: "application/json;charset=UTF-8",
            success: function (response) {
                console.log(response);
            },
            error: function (xhr, status, error) {
                console.log("Error: " + error);
            },
        });
    }
</script>
</html>